<?php
/**
* Module JLvotes Top Rated 
* 
* Displays top rated (with jlvotes) articles
* @author Anton Voynov (anton@joomline.ru)
* @copyright (C) 2010 by Anton Voynov(http://www.joomline.ru)
* @license GNU/GPL: http://www.gnu.org/copyleft/gpl.html
**/
global $mosConfig_live_site;
// No direct access
defined('_JEXEC') or die('Restricted access');
function jlv_getVotes($params) {
	$db = & JFactory::getDBO();
	$db->setQuery("	SELECT count(*) as vc, count(*)*1.1 as k,  content_id as ci 
					FROM #__jlvotes_data 
					WHERE votetype = 0
					GROUP BY ci
					UNION
					SELECT count(*) as vc, -count(*) as k, content_id as ci 
					FROM #__jlvotes_data 
					WHERE votetype = 1
					GROUP BY ci
					");
	$rows = $db->loadObjectList();

	if (count($rows) > 0)
	foreach ($rows as $row) {
		$votes[$row->ci] 		+= $row->k;
		$totalvotes[$row->ci] 	+= $row->vc;
	}
	arsort($votes);
	$votes 				= array_slice($votes,0,intval($params->get('max_items')),true);
	
	return array($votes, $totalvotes);
}

function jlv_getArticles($params,$votes) {
	$thumb_path = JPATH_BASE.DS.'images'.DS.'stories'.DS.'jlvotesmod_thumb';
	$thumb_path_site = $mosConfig_live_site.'/images/stories/jlvotesmod_thumb';
	$db = & JFactory::getDBO();
	$db->setQuery("	SELECT c.id, c.title, c.introtext, c.alias, c.catid, cat.alias as cat_alias
					FROM #__content c 
					LEFT JOIN #__categories cat ON c.catid = cat.id
					WHERE c.id IN (".implode(", ", array_keys($votes)).")
					");
	$articles = $db->loadObjectList('id');
	
	if (count($articles) > 0)
	foreach ($articles as $k=>$v) {
		if (preg_match("/<img.*?src=(?:\"|')(.*?)(?:\"|').*?>/ixm",$articles[$k]->introtext,$img) > 0) {
			$img = explode("/",$img[1]);
			$filename = $img[count($img)-1];
			if (!file_exists($thumb_path))
				mkdir($thumb_path);
			if (!file_exists($thumb_path.DS.$filename)) {
				ljvm_img_resize(JPATH_BASE.DS.implode(DS,$img),
								$thumb_path,
								$filename,
								intval($params->get('thumb_w')),
								intval($params->get('thumb_h'))
								);
			}
			$articles[$k]->image = $thumb_path_site.'/'.$filename;
		} else {
			$articles[$k]->image = false;
		}
		$articles[$k]->introtext = preg_replace("|<.*?>|ixm","",$articles[$k]->introtext); 
		$articles[$k]->introtext = preg_replace("|{.*?}|ixm","",$articles[$k]->introtext); 
		$articles[$k]->introtext = preg_replace("|\\n|ixm","",$articles[$k]->introtext); 
		$words = explode(" ",$articles[$k]->introtext);
		$words_sliced = array_slice($words,0,intval($params->get('max_words')));
		$articles[$k]->introtext = implode(" ",$words_sliced); 
		$articles[$k]->link = JRoute::_("index.php?option=com_content&view=article&id=$k:{$articles[$k]->alias}&catid={$articles[$k]->catid}:{$articles[$k]->cat_alias}"); 
		
		if (count($words_sliced) < count($words)) {
			$articles[$k]->readmore .= "... <br><a class=\"readon\" style='font-size:7pt' href=\"{$articles[$k]->link}\">".JText::_('READMORE')."</a><br/>";
		} else {
			$articles[$k]->readmore = false;
		}
	}
	
	return $articles;
}

$cache 		= & JFactory::getCache('mod_jlvotes_top');
list($votes, $totalvotes ) = $cache->call( 'jlv_getVotes',$params);	

if (count($votes) > 0) {
	$articles = $cache->call( 'jlv_getArticles',$params, $votes);	

	foreach ($votes as $ci=>$vc) { ?>
		<h4 style="margin: 0px;">
			<a href="<?=$articles[$ci]->link?>">
				<?=$articles[$ci]->title?>
			</a>
		</h4>
		<span style="font-size: 7pt; color: gray;">Проголосовало: <?=$totalvotes[$ci]?> человек</span><br/>
		<?php if ($articles[$ci]->image) :?>
			<img src="<?=$articles[$ci]->image?>" align="left" border="0" />
		<?php endif; ?>
		<?=mb_substr($articles[$ci]->introtext,0,150,'utf-8')?>
		<?php if ($articles[$ci]->readmore) :?>
			<?=$articles[$ci]->readmore?>
		<?php endif; ?>
		
		<br><hr>

	<?php }	
}

function ljvm_img_resize( $tmpname, $save_dir, $save_name, $maxwidth = 80, $maxheight = 60 ) {

	$save_dir	.= ( substr($save_dir,-1) != DS) ? DS : "";
	
	if (list($width, $height, $type, $attr)=getimagesize($tmpname)) {
		$ht=$height;
		$wd=$width;
		if($width>$maxwidth){
			$diff = $width-$maxwidth;
			$percnt_reduced = (($diff/$width)*100);
			$ht = $height-(($percnt_reduced*$height)/100);
			$wd= $width-$diff;
		}
		
		if($ht>$maxheight){
			$diff = $height-$maxheight;
			$percnt_reduced = (($diff/$height)*100);
			$wd = $width-(($percnt_reduced*$width)/100);
			$ht= $height-$diff;
		} 
		
		
		switch($type) {
			case "1": $imorig = imagecreatefromgif($tmpname); break;
			case "2": $imorig = imagecreatefromjpeg($tmpname);break;
			case "3": $imorig = imagecreatefrompng($tmpname); break;
			default:  $imorig = imagecreatefromjpeg($tmpname);
		}
		
		$im = imagecreatetruecolor($wd,$ht);
		if (imagecopyresampled($im,$imorig , 0,0,0,0,$wd,$ht,$width, $height)) {
			if (imagejpeg($im, $save_dir.$save_name)) {return true;}
			else {return false;}
		} else {
			return false;
		}			
	} else {
		return false;
	}

}

?>
<div style="text-align: center;">
	<em>
		<span style="color: #c0c0c0; font-family: arial,helvetica,sans-serif; font-size: 5pt;">
			<a target="_blank" href="http://joomline.ru/">JoomLine</a>
		</span>
	</em>
</div>